package java.util;

import java.util.function.Consumer;

public interface Iterator<E>
{
    public abstract boolean hasNext();
    
    public abstract E next();
    
    default public void remove() {
        throw new UnsupportedOperationException("remove");
    }
    
    default public void forEachRemaining(Consumer<? super E> consumer) {
        Objects.requireNonNull(consumer);
        while (this.hasNext()) {
            consumer.accept(this.next());
        }
    }
}
